<template>
	<view v-if="isShowView">
		<view class="top" :style="'height:' + systems.barHeight + 'rpx;'">
			<navigator open-type="navigateBack" hover-class="none" class="back" :style="'height:' + systems.navigationHeight + 'rpx;top:' + systems.ktxStatusHeight + 'rpx;'">
				<image src="../static/images/back.png"></image>
			</navigator>
		</view>
		<image :src="topicDetail.posterUrl ? topicDetail.posterUrl : '../static/images/topsimg.png'" class="pic"></image>
		<view class="con">
			<view class="title ddflex">
				<view class="fflex"># {{ topicDetail.title }}</view>
				<!-- <view class="gzbtn">+关注</view> -->
			</view>
			<view class="bri" v-if="topicDetail.subtitle">{{ topicDetail.subtitle }}</view>
			<view class="cy">{{ topicDetail.participantsNO }}人参与</view>
		</view>
		<view class="tab ddflex">
			<view :class="'li ' + (pType == 1 ? 'active' : '')" @click="swiPType(1)">综合</view>
			<view :class="'li ' + (pType == 2 ? 'active' : '')" @click="swiPType(2)">最新</view>
			<view :class="'li ' + (pType == 3 ? 'active' : '')" @click="swiPType(3)">浏览最多</view>
			<view :class="'li ' + (pType == 4 ? 'active' : '')" @click="swiPType(4)">评论最多</view>
		</view>
		<view class="list" v-if="officeList && officeList.length > 0">
			<view class="li" v-for="(item, index) in officeList" :key="index">
				<view class="user ddflex" @click="toUserHomePage(item.userDTO.id)">
					<image :src="item.userDTO.avatar" mode="aspectFill" class="userimg"></image>
					<view class="fflex">
						<view class="namea ddflex">
							<view class="name fflex ddflex">{{ item.userDTO.nickName }}
								<!-- <image src="../../static/images/vip_tag.png" class="vip-tag" v-if="item.userDTO.levelGrade > 0"></image> -->
								<image v-if="item.userDTO.isOpenWeRunData" style="width:15rpx;height:20rpx;margin-left: 10rpx;" src="../../static/images/yd.png"></image>
							</view>
							<view class="time">{{ item.time }}</view>
						</view>
						<view class="area" v-if="item.userDTO.cityName">{{ item.userDTO.provinceName }} {{ item.userDTO.cityName }}</view>
					</view>
				</view>
				<!-- 分享的动态 -->
				<block v-if="item.source">
					<view class="link ddflex" @click="jumpUrlDetail(item)">
						<block v-if="item.url && item.url.length > 0"><image mode="aspectFill" v-if="idx == 0" v-for="(it, idx) in item.url" :src="it" :key="idx"></image></block>
						<view class="fflex tover"><rich-text :nodes="item.content"></rich-text></view>
					</view>
				</block>
				<!-- 非分享的动态 -->
				<block v-else>
					<view v-if="item.type == 2" class="des tovers" @click="jumpUrlDetail(item)">
						<view class="wen">提问</view>
						{{ removeHtml(item.content) }}
					</view>
					<view class="des" v-else @click="jumpUrlDetail(item)"><rich-text :nodes="item.content"></rich-text></view>

					<!-- //如果有投票，就不显示图片 -->
					<block v-if="!item.qyPoll">
					<view class="video" v-if="item.isHaveVideo && config.open_community_video == 1">
						<video :src="item.url" :show-center-play-btn="false" :controls="item.isControls" :autoplay="item.isControls" :id="'myVideo'+index" @pause="videoPause(index)" @ended="videoEnded(index)"></video>
						<view class="video-play ddflex" @click="videoPlay(index)" v-if="item.isShowPlayBtn"><image src="../../static/images/play.png"></image></view>
					</view>
					<view class="imgbox ddflex" @click="jumpUrlDetail(item)" v-if="!item.isHaveVideo"><!-- @click="previewImgss(item.url, idx)" -->
						<block v-if="item.url&&item.url.length>0">
							<image mode="aspectFill" v-for="(it, idx) in item.url" :src="it" :key="idx"></image>
						</block>
					</view>
					</block>
					<!-- 话题 -->
					<view class="ddflex" v-if="item.qyDialogu">
						<view class="topic ddflex" @click="jumpUrl('/topics/detail/detail?topicId=' + item.qyDialogu.id)">
							<image src="../../static/images/topic.png"></image>
							{{ item.qyDialogu.title }}
						</view>
					</view>
					<view class="loca ddflex" @click="jumpUrlPoi(item,'/office/poi/index')" v-if="item.poiName"><image :src="picUrlss+'office_images/loca.png'"></image><text v-if="item.poiDistance > 0">{{item.poiDistance ? item.poiDistance < 1000 ? item.poiDistance+'m' : (item.poiDistance/1000).toFixed(1)+'km' : ''}}</text>{{item.poiName}}</view>
					<!-- 投票 -->
					<view :class="'vote-box' + (item.qyPoll.isEnd ? ' ends' : '')" v-if="item.qyPoll">
						<view class="vote-tit">{{ item.qyPoll.title }}</view>
						<block v-if="item.qyPoll.isVote == 1">
							<view class="vote-list end" @click="jumpUrlDetail(item)">
								<view :class="'lis ddflex  ' + (itpy.isVote == 1 ? 'active' : '')" v-for="(itpy, idex) in JSON.parse(item.qyPoll.optionJson)" :key="idex">
									<view class="percent" :style="'width:' + parseFloat(itpy.proportion) + '%;'"></view>
									<view class="fflex">{{ itpy.name }}</view>
									<view>{{ parseFloat(itpy.proportion) + '%' }}</view>
								</view>
							</view>
						</block>
						<block v-else>
							<view class="vote-list">
								<view class="lis" v-for="(itpy, idex) in JSON.parse(item.qyPoll.optionJson)" :key="idex" @click="submitPoll(item, index, idex)">
									{{ itpy.name }}
								</view>
							</view>
						</block>
						<view class="vote-can" v-if="item.qyPoll.isEnd">
							<text>{{ item.qyPoll.voteCount }}人参与</text>
							投票已结束
						</view>
					</view>
					<block v-if="item.type==10||item.type==11">
						<view v-if="item.type==10" class="ddflex step-box" style="justify-content: space-between;" @click="jumpUrl('/exercise/record/record?userId=' + item.userId)">
							<view>
								<view class="step-date">{{item.wxRun.step}}</view>
								<view class="step-label">步数</view>
							</view>
							<view>
								<view class="step-date">{{item.wxRun.index}}</view>
								<view class="step-label" style="text-align: right;">名次</view>
							</view>
						</view>
						<view v-if="item.type==11" class="ddflex step-box" style="justify-content: space-between;" @click="jumpUrl('/match/activityDetail/activityDetail?id=' + item.matchContent.id)">
							<image class="step-pic" :src="item.matchContent.pic" mode="aspectFill"></image>
							<view class="fflex">
								<view class="step-title tovers">{{item.matchContent.title}}</view>
								<view class="ddflex" style="justify-content: space-between;margin-top: 10rpx;">
									<view class="step-price">{{item.matchContent.endTime}}</view>
									<view  class="step-btn">查看</view>
								</view>
							</view>
						</view>
					</block>
					<view v-if="item.userGroupId" class="ddflex step-box" style="padding: 25rpx 21rpx;" @click="jumpUrl('/office/team/index?id=' + item.userGroupId)">
						<image style="width: 24rpx;height: 24rpx;margin-right: 13rpx;" src="../../static/images/link.png"></image>
						<view style="font-weight: 500;color: #999999;">Team：</view>
						<view>{{item.userGroupTitle}}</view>
					</view>
				</block>
				<view class="opt ddflex" v-if="!item.source">
					<view class="fflex" @click="jumpUrlDetail(item)">{{ item.count.browseCount }}次浏览</view>
					<view class="ddflex" @click="submitFabulous(2, item.id, index)">
						<image :src="'../../static/images/' + (item.isPraise == 1 ? 'like_h' : 'like') + '.png'"></image>
						{{ item.count.fabulousCount < 99 ? item.count.fabulousCount : '99+' }}
					</view>
					<view class="ddflex" @click="jumpUrlDetail(item)">
						<image src="../../static/images/comment.png"></image>
						{{ item.count.commentCount < 99 ? item.count.commentCount : '99+' }}
					</view>
					<!-- #ifdef MP-WEIXIN -->
					<button open-type="share" class="opt-share ddflex" :data-item="item">
						<image src="../../static/images/share.png"></image>
						分享
					</button>
					<!-- #endif -->
					<!-- #ifdef APP-PLUS -->
					<view class="opt-share ddflex" @click="appToShare(item)">
						<image src="../../static/images/share.png"></image>
						分享
					</view>
					<!-- #endif -->
				</view>
			</view>
		</view>
		<view class="nodata" v-else>
			<image :src="picUrlss + 'empty_jl.png'"></image>
			<text>暂无动态</text>
		</view>
		<view class="create" v-if="config.is_show_create_btn == 1" @click="createJump('/office/news/news?topicId=' + topicId)">
			<image style="display: block;" src="../../static/images/create.png"></image>
			发帖
		</view>
		<!-- <view class="create" @click="showBtn"><image src="../../static/images/create.png"></image>发布</view> -->
		<!-- <view class="ceng" v-if="isShowbtn" @click="hideBtn"></view>
		<view class="side ddflex" v-if="isShowbtn">
			<view class="li" @click="createJump('/office/diary/diary')">
				<image src="../../static/images/quanzi.png"></image>
				<view>创建话题</view>
			</view>
			<view class="li" @click="createJump('/office/news/news?topicId=' + topicId)">
				<image src="../../static/images/tiezi.png"></image>
				<view>发帖</view>
			</view>
		</view> -->
	</view>
</template>

<script>
const app = getApp();
const req = require('../../utils/request.js');
const util = require('../../utils/util.js');
export default {
	data() {
		return {
			picUrlss: req.public.picUrls,
			systems: {},
			isShowbtn: false,
			topicId: '', //话题ID
			isLoad: true,
			form: {
				page: 1,
				limit: 10
			},
			pType: 1, //排序： 1综合, 2最新,3浏览最多,4评论最多,5热门
			officeList: [],
			isShowView: false,
			topicDetail: '',
			videoCurrent: null,
			videoContext: '',
			config: {},
			currentPoi: {}
		};
	},
	onLoad(opt) {
		this.topicId = opt.topicId;
		req.saveBehaviorNew(this.topicId,21,4)
	},
	onShow() {
		this.getTopicsInfo();
		this.swiPType(1);
		this.config = JSON.parse(req.getStorage('configRes'))
	},

	onShareAppMessage(option) {
		let item = option.target.dataset.item; //取到传入的参数
		console.log('==', item);
		var url = '/office/detail/detail?contentId=' + item.id;
		var img = '';
		if (item.url) {
			var imgList = item.url;
			img = imgList[0];
		} else {
		}
		req.saveBehaviorNew(item.id, item.pollId?10:11,6)
		return {
			title: util.removeHtml(item.content),
			imageUrl: img,
			path: url
		};
	},

	onReachBottom() {
		this.form.page++;
		this.getOfficeList();
	},
	onHide() {
		this.isShowbtn = false;
	},
	methods: {
		showBtn() {
			this.isShowbtn = true;
		},
		hideBtn() {
			this.isShowbtn = false;
		},
		removeHtml(content) {
			return util.removeHtml(content);
		},
		createJump(url) {
			if (!req.isLogins(true)) {
				return;
			}
			this.jumpUrl(url);
		},
		jumpUrl(url) {
			uni.navigateTo({
				url: url
			});
		},
		jumpUrlPoi(item,url){
			this.currentPoi = item;
			uni.navigateTo({
				url: url
			})
		},
		//预览图片
		previewImgss(picUrls, index) {
			//预览合同图片
			var src = picUrls[index];
			let imgs = picUrls;
			uni.previewImage({
				current: src, // 当前显示图片的http链接
				urls: imgs
			});
		},

		jumpUrlDetail(item) {
			if (item.source) {
				this.jumpUrl('/office/detail/detail?contentId=' + item.source);
			} else {
				this.jumpUrl('/office/detail/detail?contentId=' + item.id);
			}
		},

		//切换类型
		swiPType(type) {
			this.isLoad = true;
			this.form.page = 1;
			this.pType = type;
			this.getOfficeList();
		},
		toUserHomePage(userId) {
			this.jumpUrl('/topics/home/home?userId=' + userId);
		},

		getTopicsInfo() {
			req.getRequest('/api/v3/dialogue/info', { id: this.topicId }, data => {
				this.topicDetail = data;
				this.isShowView = true;
			});
		},

		sum(arr) {
			var s = 0;
			for (var i = arr.length - 1; i >= 0; i--) {
				if (arr[i].count) {
					s += Number(arr[i].count);
				}
			}
			return s;
		},

		getOfficeList() {
			let that = this;
			var pramData = this.form;
			pramData.dialogueId = this.topicId;
			pramData.orderType = this.pType;
			if (!this.isLoad) return false;
			this.isLoad = false;
			req.getRequest('/api/v3/moments/list', pramData, data => {
				if (data && data.length > 0) {
					data.map(it => {
						if (it.qyPoll && it.qyPoll.isEnd) {
							it.qyPoll.voteCount = that.sum(JSON.parse(it.qyPoll.optionJson));
						}
						if(it.url){
							let h = it.url.substring(it.url.lastIndexOf('.') + 1)
							if(h.indexOf('mp4')<0&&h.indexOf('MP4')<0){
								it.url = it.url.split(',');
							}else{
								it.isHaveVideo = true
								it.isControls = false
								it.isShowPlayBtn = true
							}
						}
						it.content = '<div style="overflow: hidden;text-overflow: ellipsis;display: -webkit-box;-webkit-line-clamp: 5;-webkit-box-orient: vertical;word-break: break-all;">' + it.content + '</div>'
						return it;
					});
				}
				if (data && data.length >= this.form.limit) {
					this.isLoad = true;
				}
				if (this.form.page > 1) {
					data = this.officeList.concat(data);
				}
				this.officeList = data;
				this.isShowView = true;
			});
		},
		//提交点赞、取消点赞；收藏、取消收藏
		submitFabulous(type, id, index) {
			if (!req.isLogins(true)) {
				return;
			}
			var dataP = {};
			dataP.type = type; //1，观看 ，2点赞，3评论，4分享，5收藏
			dataP.momentsId = id;
			req.postRequestLoding('/api/v3/fabulous/save', dataP, data => {
				if (type == 2) {
					//动态点赞
					if (this.officeList[index].isPraise == 1) {
						//已赞
						this.officeList[index].isPraise = 0;
						this.officeList[index].count.fabulousCount--;
						req.saveBehaviorNew(id, this.officeList[index].pollId?10:11,11)
					} else {
						this.officeList[index].isPraise = 1;
						this.officeList[index].count.fabulousCount++;
						req.saveBehaviorNew(id, this.officeList[index].pollId?10:11,3)
					}
				}
			});
		},

		//提交投票
		submitPoll(item, pIndex, pollIndex) {
			if (item.qyPoll.isEnd) return req.msg('投票已结束');
			var dataP = {};
			// dataP.id = item.id;
			dataP.pollId = item.qyPoll.id;
			var pollObjList = JSON.parse(item.qyPoll.optionJson);
			dataP.pollOptionCode = pollObjList[pollIndex].code;
			req.postRequest('/api/v3/poll/saveDetails', dataP, data => {
				req.msg('投票成功');
				//图片完之后要将该投票的对象返回，便于做渲染%
				this.officeList[pIndex].qyPoll = data;
				req.saveBehaviorNew(item.id,10,5)
			});
		},
		appToShare(item) {
			console.log('数据>>>>', item);
			var img = '';
			if (item.url) {
				var imgList = item.url;
				img = imgList[0];
			} else {
				let config = JSON.parse(req.getStorage('configRes'));
				img = config.share_pic;
			}
			console.log('数据>>>>2222', img);
			var text = util.removeHtml(item.content);
			uni.share({
				provider: 'weixin',
				scene: 'WXSceneSession',
				type: 5,
				imageUrl: img,
				title: text,
				summary: text,
				miniProgram: {
					id: req.public.miniProgramGh_id,
					path: 'office/detail/detail?contentId=' + item.id,
					type: 0,
					webUrl: 'http://www.lemonban.com'
				},
				success: ret => {
					console.log(ret);
				},
				fail: ret => {
					console.log(ret);
				}
			});
		},
		videoPlay(index){
		    var that = this;
		    var curIdx = index;
		    this.officeList[index].isControls = true
		    this.officeList[index].isShowPlayBtn = false
		    // 有播放时先将prev暂停，再播放当前点击的current
		    if (that.videoCurrent != null) {
				var videoContextPrev = uni.createVideoContext('myVideo' + that.videoCurrent)
				if (that.videoCurrent != curIdx) {
					this.officeList[that.videoCurrent].isControls = false
					this.officeList[that.videoCurrent].isShowPlayBtn = true
					
					videoContextPrev.stop()
				}
				that.videoCurrent = curIdx
				var videoContextCurrent = uni.createVideoContext('myVideo' + curIdx)
				videoContextCurrent.play()
		    } else {  
				// 没有播放时播放视频
				that.videoCurrent = curIdx
				var videoContext = uni.createVideoContext('myVideo' + curIdx) // 对应的视频id
				videoContext.play()
		    }
		},
		videoPause(index){
			this.officeList[index].isControls = false
			this.officeList[index].isShowPlayBtn = true
		},
		videoEnded(index){
			this.officeList[index].isControls = false
			this.officeList[index].isShowPlayBtn = true
		}
	},
	created() {
		const systemInfo = uni.getSystemInfoSync();
		// px转换到rpx的比例
		let pxToRpxScale = 750 / systemInfo.windowWidth;
		let systems = {
			ktxStatusHeight: systemInfo.statusBarHeight * pxToRpxScale, // 状态栏的高度
			navigationHeight: 44 * pxToRpxScale // 导航栏的高度
		};
		systems.barHeight = systems.ktxStatusHeight + systems.navigationHeight;
		this.systems = systems;
	}
}; 
</script>

<style>
@import './detail.css';
</style>
